# README #

## Fresenius ASN Project ##

Fresenius would like their Order Management System, IntelliOrder (IO) hosted by AmerisourceBergen (AB), to provide Advance Ship Notices (ASNs) to the BCD system.

Once in the BCD system, the ASNs will be pushed to Devices for Receiving workflow.

All Receipts will flow from the devices to the BCD database. From there, BCD will be responsible for pushing datat to the Fresensius SAP system.

### What is this repository for? ###

This project is responsible for

* Reading ASN data from the database (via REST)
* Writing ASN data to the database (via REST)
* Writing ASN data to the database (via Message Queue)

### How do I get set up? ###

* Clone this repository.
* In the folder where this is cloned, open a command prompt. Type:
> npm install
* Launch IntelliJ Ultimate (license required) with NodeJS plugin
* Create a "New Project with Existing Sources..."

### How do I run? ###

#### ENV VARS ####

* NODE_ENV = dev|qa|prod|test    (test = mocha tests)
* PORT = web port to listen

#### Multithreaded (requires server with more than one core) ####
* Splits duty in half by number of cores: Web and Queue Consumption
* If there's an odd number of cores, queue consumption takes the extra core
> node.exe master.js

#### Single core ####
* All on one core
> node.exe server.js 

### How do I manage a cluster? ###

#### Signals ####

While the cluster manager is running, you can send signals.

*To reload workers - start new ones and shut down the old ones.

> kill -HUP MASTERPID

*To output to stdout number of workers and their PIDs

> kill -USR1 MASTERPID

*To increase running workers to the maximum number set at the start

> kill -USR2 MASTERPID

*To attempt graceful shutdown

> kill -TERM MASTERPID

### Who do I talk to? ###

* John Amaral