"use strict";

var models = require('./components/models');

var env         = process.env.NODE_ENV || "dev";
var config      = require("./components/config/server." + env + ".js");

//initialize logging
const winston = require('winston');
require('./components/config/logging')(winston);
var logger = winston.loggers.get('default');

if  (config.mqs && config.mqs === "rabbit")
    require("./components/services/RabbitSubscriber")(winston, models, config);

if  (config.mqs && config.mqs === "sqs")
    require("./components/services/SQSSubscriber")(winston, models, config);

    module.exports = logger;
