/**
 * Created by John on 4/4/2017.
 */
var cluster = require('cluster');
var clusterManager = require('cluster-manager');
var port = process.env.PORT || 3000;
var numCPUs = require('os').cpus().length;
var env = process.env.NODE_ENV || "dev";
var path = require('path');

var webpath = path.join(__dirname, 'childWeb.js');
var qpath = path.join(__dirname, 'childQueues.js');


if (numCPUs === 1) {
    throw new Error("Use server.js for single core machines!");
}

if (cluster.isMaster) {
    var isEven = (numCPUs % 2 === 0);
    if (!isEven) numCPUs--;

    var forks = numCPUs / 2;

    cluster.on('online', function(worker) {
        console.log('Worker ' + worker.process.pid + ' is online');
    });

    clusterManager({
        exec: webpath,
        workers: forks,
        notify: null
    });

    //allocate the extra core to queue drainage

    if (!isEven) forks++;
    clusterManager({
        exec: qpath,
        workers: forks,
        notify: null
    });

}

process.on('uncaughtException', function (err) {
    var msg = (new Date).toUTCString() + ' uncaughtException:';
    console.error(msg, err.message);
    console.error(err.stack);
    process.exit(1);
});