/**
 * Created by John on 7/6/2017.
 */
var path = require('path');
var config = require(path.join(__dirname,  '..', '/components/config/server.test.js'));
var expect = require('chai').expect;
var TestHelper = require("./TestHelper");

describe("Fresenius ASN Web APIs", function() {

    it('should get all ASNs', function(done){
        var models = require("../components/models");
        var AsnHelper = require("../components/helpers/AsnHelper");
        var helper = new AsnHelper(models);
        var req = {
            body: {
                limit: null,
                offset: 0
            }
        };
        helper.getAllASNs(req).then(function(result){
            expect(result).to.not.be.null;
            expect(result.count).to.be.greaterThan(0);
            expect(Array.isArray(result.rows)).to.be.true;
            done();
        }).catch(function(err){
            expect(err).to.be.null;
            done();
        });
    }).timeout(15000);







});