{"filter":false,"title":"CONTRIBUTING.md","tooltip":"/CONTRIBUTING.md","undoManager":{"mark":73,"position":73,"stack":[[{"start":{"row":0,"column":0},"end":{"row":108,"column":48},"action":"insert","lines":["# Contributing to node-libnmap","","## Code Contributions","","This document will guide you through the contribution process.","","### Step 1: Fork","","Fork the project [on GitHub](https://github.com/jas-/node-libnmap) and check out your","copy locally.","","```text","$ git clone git@github.com:username/node-libnmap.git","$ cd node","$ git remote add upstream git://github.com/jas-/node-libnmap.git","```","","Keep your local fork update to date using the `upstream` branch indicated in ","the above commands.","","#### Which branch?","","For developing new features and bug fixes, the `master` branch should be pulled","and built upon.","","### Step 2: Branch","","Create a feature branch and start hacking:","","```text","$ git checkout -b my-feature-branch -t origin/master","```","","The branch name should be descriptive about the fixes/features it will","address.","","### Step 3: Commit","","Make sure git knows your name and email address:","","```text","$ git config --global user.name \"J. Random User\"","$ git config --global user.email \"j.random.user@example.com\"","```","","Writing good commit logs is important.  A commit log should describe what","changed and why.  Follow these guidelines when writing one:","","1. The first line should be 50 characters or less and contain a short","   description of the change prefixed with the name of the changed","   subsystem (e.g. \"net: add localAddress and localPort to Socket\").","2. Keep the second line blank.","3. Wrap all other lines at 72 columns.","","A good commit log can look something like this:","","```","subsystem: explaining the commit in one line","","Body of commit message is a few lines of text, explaining things","in more detail, possibly giving some background about the issue","being fixed, etc. etc.","","The body of the commit message can be several paragraphs, and","please do proper word-wrap and keep columns shorter than about","72 characters or so. That way `git log` will show things","nicely even when it is indented.","```","","The header line should be meaningful; it is what other people see when they","run `git shortlog` or `git log --oneline`.","","Check the output of `git log --oneline files_that_you_changed` to find out","what subsystem (or subsystems) your changes touch.","","","### Step 4: Rebase","","Use `git rebase` (not `git merge`) to sync your work from time to time (as","mentioned in 'Step 1').","","```text","$ git fetch upstream","$ git rebase upstream/master","```","","### Step 5: Test","","Bug fixes and features **should come with tests**.  Add your tests in the","test directory.  Look at other tests to see how they should be","structured.","","```text","$ npm test","```","","### Step 6: Push","","```text","$ git push origin my-feature-branch","```","","Go to https://github.com/yourusername/node-libnmap and select your feature","branch. Click the 'Pull Request' button and fill out the form.","","Pull requests are usually reviewed within a few days.  If there are comments","to address, apply your changes in a separate commit and push that to your","feature branch.  Post a comment in the pull request afterwards; GitHub does","not send out notifications when you add commits."],"id":1}],[{"start":{"row":102,"column":38},"end":{"row":102,"column":50},"action":"remove","lines":["node-libnmap"],"id":2},{"start":{"row":102,"column":38},"end":{"row":102,"column":39},"action":"insert","lines":["c"]}],[{"start":{"row":102,"column":39},"end":{"row":102,"column":40},"action":"insert","lines":["o"],"id":3}],[{"start":{"row":102,"column":40},"end":{"row":102,"column":41},"action":"insert","lines":["n"],"id":4}],[{"start":{"row":102,"column":41},"end":{"row":102,"column":42},"action":"insert","lines":["n"],"id":5}],[{"start":{"row":102,"column":42},"end":{"row":102,"column":43},"action":"insert","lines":["e"],"id":6}],[{"start":{"row":102,"column":43},"end":{"row":102,"column":44},"action":"insert","lines":["c"],"id":7}],[{"start":{"row":102,"column":44},"end":{"row":102,"column":45},"action":"insert","lines":["t"],"id":8}],[{"start":{"row":102,"column":45},"end":{"row":102,"column":46},"action":"insert","lines":["-"],"id":9}],[{"start":{"row":102,"column":46},"end":{"row":102,"column":47},"action":"insert","lines":["m"],"id":10}],[{"start":{"row":102,"column":47},"end":{"row":102,"column":48},"action":"insert","lines":["y"],"id":11}],[{"start":{"row":102,"column":48},"end":{"row":102,"column":49},"action":"insert","lines":["s"],"id":12}],[{"start":{"row":102,"column":49},"end":{"row":102,"column":50},"action":"insert","lines":["q"],"id":13}],[{"start":{"row":102,"column":50},"end":{"row":102,"column":51},"action":"insert","lines":["l"],"id":14}],[{"start":{"row":14,"column":43},"end":{"row":14,"column":60},"action":"remove","lines":["jas-/node-libnmap"],"id":15},{"start":{"row":14,"column":43},"end":{"row":14,"column":44},"action":"insert","lines":["n"]}],[{"start":{"row":14,"column":44},"end":{"row":14,"column":45},"action":"insert","lines":["l"],"id":16}],[{"start":{"row":14,"column":45},"end":{"row":14,"column":46},"action":"insert","lines":["f"],"id":17}],[{"start":{"row":14,"column":46},"end":{"row":14,"column":47},"action":"insert","lines":["/"],"id":18}],[{"start":{"row":14,"column":47},"end":{"row":14,"column":48},"action":"insert","lines":["c"],"id":19}],[{"start":{"row":14,"column":48},"end":{"row":14,"column":49},"action":"insert","lines":["o"],"id":20}],[{"start":{"row":14,"column":49},"end":{"row":14,"column":50},"action":"insert","lines":["n"],"id":21}],[{"start":{"row":14,"column":50},"end":{"row":14,"column":51},"action":"insert","lines":["n"],"id":22}],[{"start":{"row":14,"column":51},"end":{"row":14,"column":52},"action":"insert","lines":["e"],"id":23}],[{"start":{"row":14,"column":52},"end":{"row":14,"column":53},"action":"insert","lines":["c"],"id":24}],[{"start":{"row":14,"column":53},"end":{"row":14,"column":54},"action":"insert","lines":["t"],"id":25}],[{"start":{"row":14,"column":54},"end":{"row":14,"column":55},"action":"insert","lines":["-"],"id":26}],[{"start":{"row":14,"column":55},"end":{"row":14,"column":56},"action":"insert","lines":["m"],"id":27}],[{"start":{"row":14,"column":56},"end":{"row":14,"column":57},"action":"insert","lines":["y"],"id":28}],[{"start":{"row":14,"column":57},"end":{"row":14,"column":58},"action":"insert","lines":["s"],"id":29}],[{"start":{"row":14,"column":58},"end":{"row":14,"column":59},"action":"insert","lines":["q"],"id":30}],[{"start":{"row":14,"column":59},"end":{"row":14,"column":60},"action":"insert","lines":["l"],"id":31}],[{"start":{"row":12,"column":36},"end":{"row":12,"column":48},"action":"remove","lines":["node-libnmap"],"id":32},{"start":{"row":12,"column":36},"end":{"row":12,"column":37},"action":"insert","lines":["c"]}],[{"start":{"row":12,"column":37},"end":{"row":12,"column":38},"action":"insert","lines":["o"],"id":33}],[{"start":{"row":12,"column":38},"end":{"row":12,"column":39},"action":"insert","lines":["n"],"id":34}],[{"start":{"row":12,"column":39},"end":{"row":12,"column":40},"action":"insert","lines":["n"],"id":35}],[{"start":{"row":12,"column":40},"end":{"row":12,"column":41},"action":"insert","lines":["e"],"id":36}],[{"start":{"row":12,"column":41},"end":{"row":12,"column":42},"action":"insert","lines":["c"],"id":37}],[{"start":{"row":12,"column":42},"end":{"row":12,"column":43},"action":"insert","lines":["t"],"id":38}],[{"start":{"row":12,"column":43},"end":{"row":12,"column":44},"action":"insert","lines":["-"],"id":39}],[{"start":{"row":12,"column":44},"end":{"row":12,"column":45},"action":"insert","lines":["m"],"id":40}],[{"start":{"row":12,"column":45},"end":{"row":12,"column":46},"action":"insert","lines":["y"],"id":41}],[{"start":{"row":12,"column":46},"end":{"row":12,"column":47},"action":"insert","lines":["s"],"id":42}],[{"start":{"row":12,"column":47},"end":{"row":12,"column":48},"action":"insert","lines":["q"],"id":43}],[{"start":{"row":12,"column":48},"end":{"row":12,"column":49},"action":"insert","lines":["l"],"id":44}],[{"start":{"row":8,"column":48},"end":{"row":8,"column":65},"action":"remove","lines":["jas-/node-libnmap"],"id":45},{"start":{"row":8,"column":48},"end":{"row":8,"column":49},"action":"insert","lines":["n"]}],[{"start":{"row":8,"column":49},"end":{"row":8,"column":50},"action":"insert","lines":["l"],"id":46}],[{"start":{"row":8,"column":50},"end":{"row":8,"column":51},"action":"insert","lines":["f"],"id":47}],[{"start":{"row":8,"column":51},"end":{"row":8,"column":52},"action":"insert","lines":["/"],"id":48}],[{"start":{"row":8,"column":52},"end":{"row":8,"column":53},"action":"insert","lines":["c"],"id":49}],[{"start":{"row":8,"column":53},"end":{"row":8,"column":54},"action":"insert","lines":["o"],"id":50}],[{"start":{"row":8,"column":54},"end":{"row":8,"column":55},"action":"insert","lines":["n"],"id":51}],[{"start":{"row":8,"column":55},"end":{"row":8,"column":56},"action":"insert","lines":["n"],"id":52}],[{"start":{"row":8,"column":56},"end":{"row":8,"column":57},"action":"insert","lines":["e"],"id":53}],[{"start":{"row":8,"column":57},"end":{"row":8,"column":58},"action":"insert","lines":["c"],"id":54}],[{"start":{"row":8,"column":58},"end":{"row":8,"column":59},"action":"insert","lines":["t"],"id":55}],[{"start":{"row":8,"column":59},"end":{"row":8,"column":60},"action":"insert","lines":["-"],"id":56}],[{"start":{"row":8,"column":60},"end":{"row":8,"column":61},"action":"insert","lines":["m"],"id":57}],[{"start":{"row":8,"column":61},"end":{"row":8,"column":62},"action":"insert","lines":["y"],"id":58}],[{"start":{"row":8,"column":62},"end":{"row":8,"column":63},"action":"insert","lines":["s"],"id":59}],[{"start":{"row":8,"column":63},"end":{"row":8,"column":64},"action":"insert","lines":["q"],"id":60}],[{"start":{"row":8,"column":64},"end":{"row":8,"column":65},"action":"insert","lines":["l"],"id":61}],[{"start":{"row":0,"column":18},"end":{"row":0,"column":30},"action":"remove","lines":["node-libnmap"],"id":62},{"start":{"row":0,"column":18},"end":{"row":0,"column":19},"action":"insert","lines":["c"]}],[{"start":{"row":0,"column":19},"end":{"row":0,"column":20},"action":"insert","lines":["o"],"id":63}],[{"start":{"row":0,"column":20},"end":{"row":0,"column":21},"action":"insert","lines":["n"],"id":64}],[{"start":{"row":0,"column":21},"end":{"row":0,"column":22},"action":"insert","lines":["n"],"id":65}],[{"start":{"row":0,"column":22},"end":{"row":0,"column":23},"action":"insert","lines":["e"],"id":66}],[{"start":{"row":0,"column":23},"end":{"row":0,"column":24},"action":"insert","lines":["c"],"id":67}],[{"start":{"row":0,"column":24},"end":{"row":0,"column":25},"action":"insert","lines":["t"],"id":68}],[{"start":{"row":0,"column":25},"end":{"row":0,"column":26},"action":"insert","lines":["-"],"id":69}],[{"start":{"row":0,"column":26},"end":{"row":0,"column":27},"action":"insert","lines":["m"],"id":70}],[{"start":{"row":0,"column":27},"end":{"row":0,"column":28},"action":"insert","lines":["y"],"id":71}],[{"start":{"row":0,"column":28},"end":{"row":0,"column":29},"action":"insert","lines":["s"],"id":72}],[{"start":{"row":0,"column":29},"end":{"row":0,"column":30},"action":"insert","lines":["q"],"id":73}],[{"start":{"row":0,"column":30},"end":{"row":0,"column":31},"action":"insert","lines":["l"],"id":74}]]},"ace":{"folds":[],"scrolltop":0,"scrollleft":0,"selection":{"start":{"row":67,"column":0},"end":{"row":67,"column":0},"isBackwards":false},"options":{"guessTabSize":true,"useWrapMode":false,"wrapToView":true},"firstLineState":0},"timestamp":1504535680962,"hash":"5960864912ab7758e9e6481af2765a64b3f02882"}